<template>
<div>
  <b-row>
    <b-colxx xxs="12">
        <div class="top-right-button-container">
          <b-button
            v-b-modal.modalbasic
            variant="danger"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length <= 0"
          >supprimer</b-button>
          <b-button
            v-b-modal.modalright
            variant="primary"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length != 1"
          >modifier</b-button>
          <b-modal id="modalbasic" ref="modalbasic" :title="'Suppression'">
            Voulez-vous vraiment supprimer le(s) {{ bootstrapTable.selected.length }} user(s) séléctionnés ?
            <template slot="modal-footer">
                <b-button variant="primary" @click="deleteUsers()" class="mr-1">Confirmer</b-button>
                <b-button variant="secondary" @click="hideModal('modalbasic')">Annuler</b-button>
            </template>
          </b-modal>
          <b-modal
            id="modalright"
            ref="modalright"
            :title="'Edit user'"
            class="modal-right"
          >
            <b-form v-if="bootstrapTable.selected[0]">
              <b-form-group :label="'Username'">
                <b-form-input v-model="bootstrapTable.selected[0].username" />
              </b-form-group>
              <b-form-group :label="'Firstname'">
                <b-form-input v-model="bootstrapTable.selected[0].firstName" />
              </b-form-group>
              <b-form-group :label="'Lastname'">
                <b-form-input v-model="bootstrapTable.selected[0].lastName"/>
              </b-form-group>
              <b-form-group :label="'Email'">
                <b-form-input v-model="bootstrapTable.selected[0].email" />
              </b-form-group>
              <b-form-group :label="'Role'">
                <b-form-select v-model="bootstrapTable.selected[0].role" :options="optionsRole" />
              </b-form-group>
            </b-form>

            <template slot="modal-footer">
              <b-button
                variant="outline-secondary"
                @click="hideModal('modalright')"
              >annuler</b-button>
              <b-button
                variant="primary"
                @click="updateUser()"
                class="mr-1"
              >valider</b-button>
            </template>
          </b-modal>
        </div>

      <piaf-breadcrumb heading="Users"/>
      <div class="separator mb-5">
      </div>
    </b-colxx>
  </b-row>
  <b-row>
    <b-colxx xxs="12">
      <b-card class="mb-4" title="Users">
        <b-table
            ref="custom-table"
            class="vuetable"
            sort-by="title" sort-desc.sync="false"
            @row-selected="rowSelected"
            selectable
            :select-mode="bootstrapTable.selectMode"
            :current-page="currentPage"
            selectedVariant="primary"
            :fields="bootstrapTable.fields"
            :items="items"
          >
          <template slot="status" slot-scope="data">
            <b-badge class="mb-1" :variant="data.item.statusColor">{{ data.value }}</b-badge>
          </template>
          </b-table>
        <b-pagination
            size="sm"
            align="center"
            :total-rows="totalRows"
            :per-page="perPage"
            v-model="currentPage"
          >
            <template v-slot:next-text>
              <i class="simple-icon-arrow-right"/>
            </template>
            <template v-slot:prev-text>
              <i class="simple-icon-arrow-left"/>
            </template>
            <template v-slot:first-text>
              <i class="simple-icon-control-start"/>
            </template>
            <template v-slot:last-text>
              <i class="simple-icon-control-end"/>
            </template>
          </b-pagination>

          <!-- <b-alert v-if="bootstrapTable.selected.length>0" show variant="primary">Selected Items :<br/><pre>{{ bootstrapTable.selected }}</pre></b-alert> -->
      </b-card>
    </b-colxx>
  </b-row>
  </div>
</template>
<script>
import Vue from 'vue'

export default {
  components: {

  },
  data () {
    return {
      items: [],
      currentPage: 1,
      perPage: 5,
      totalRows: 0,
      bootstrapTable: {
        selected: [],
        selectMode: 'multi',
        fields: [
          { key: 'firstName', label: 'Firstname', sortable: true, sortDirection: 'desc', tdClass: 'list-item-heading' },
          { key: 'lastName', label: 'Lastname', sortable: true, tdClass: 'text-muted' },
          { key: 'email', label: 'E-mail', sortable: true, tdClass: 'text-muted' },
          { key: 'username', label: 'Username', sortable: true, tdClass: 'text-muted' }
        ]
      },
      optionsRole: [
        { value: true, text: 'Admin' },
        { value: false, text: 'User' }
      ],
      selectedUser: {}
    }
  },
  methods: {
    onPaginationData (paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    onChangePage (page) {
      this.$refs.vuetable.changePage(page)
    },
    rowSelected (items) {
      this.bootstrapTable.selected = items
      this.selectedUser = items[0]
    },
    async dataProvider (ctx) {
      // let promise = Vue.prototype.$http.get('http://localhost:3000/api/users')

      return await Vue.prototype.$http.get('http://localhost:3000/api/users')
        .then(result => result.data)
        .then((data) => {
          this.currentPage = data.current_page
          this.perPage = data.per_page
          this.totalRows = data.total
          this.items = data
          return this.items
        }).catch(_error => {
          return []
        })
    },
    apiParamsConverter (params) {
      let apiParams = {}
      if (params.perPage !== 0) {
        apiParams.per_page = params.perPage
      }
      if (params.currentPage >= 1) {
        apiParams.page = params.currentPage
      }
      if (params.sortBy.length > 0) {
        apiParams.sort = `${params.sortBy}|${params.sortDesc ? 'desc' : 'asc'}`
      }
      if (params.filter.length > 0) {
        // Optional
      }
      return apiParams
    },
    hideModal (refname) {
      this.$refs[refname].hide()
      this.dataProvider()
    },
    updateUser () {
      this.hideModal('modalright')
      Vue.prototype.$http.patch('http://localhost:3000/api/users/' + this.bootstrapTable.selected[0].id, this.bootstrapTable.selected[0])
        .then(res => {
          this.dataProvider()
        })
        // .catch(err => { console.log(err) })
    },
    deleteUsers () {
      this.hideModal('modalbasic')
      this.bootstrapTable.selected.forEach(u => {
        Vue.prototype.$http.delete('http://localhost:3000/api/users/' + u.id).then(res => {
          const index = this.items.indexOf(u)
          if (index > -1) {
            this.items.splice(index, 1)
          }
          this.dataProvider()
        })
      })
    }
  },
  mounted () {
    this.dataProvider()
  }
}
</script>
